#include "timer.h"
#include "led.h"
#include "usart.h"
#include "sys.h"


char BPC_Get_Status=0;
//u8 bhour=0,bmin=0,bweek=0,bday=0,bmon=0,byear=0,wu=0,bsec=0;

//ʱ2ͨ1벶

TIM_ICInitTypeDef  TIM2_ICInitStructure;

void TIM2_Cap_Init(u16 arr,u16 psc)
{	 
	GPIO_InitTypeDef GPIO_InitStructure;
	TIM_TimeBaseInitTypeDef  TIM_TimeBaseStructure;
 	NVIC_InitTypeDef NVIC_InitStructure;

	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM2, ENABLE);	//ʹTIM2ʱ
 	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);  //ʹGPIOAʱ
	
	GPIO_InitStructure.GPIO_Pin  = GPIO_Pin_0;  //PA0 ֮ǰ  
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPD; //PA0   
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	//GPIO_ResetBits(GPIOA,GPIO_Pin_0);						 //PA0 
	GPIO_SetBits(GPIOA,GPIO_Pin_0);
	
	//ʼʱ2 TIM2	 
	TIM_TimeBaseStructure.TIM_Period = arr; //趨Զװֵ 
	TIM_TimeBaseStructure.TIM_Prescaler =psc; 	//ԤƵ   
	TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1; //ʱӷָ:TDTS = Tck_tim
	TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;  //TIMϼģʽ
	TIM_TimeBaseInit(TIM2, &TIM_TimeBaseStructure); //TIM_TimeBaseInitStructָĲʼTIMxʱλ
  
	//ʼTIM2벶
	TIM2_ICInitStructure.TIM_Channel = TIM_Channel_1; //CC1S=01 	ѡ IC1ӳ䵽TI1
     //TIM2_ICInitStructure.TIM_ICPolarity = TIM_ICPolarity_Rising;	//ز
	 TIM2_ICInitStructure.TIM_ICPolarity = TIM_ICPolarity_Falling;
  	TIM2_ICInitStructure.TIM_ICSelection = TIM_ICSelection_DirectTI; //ӳ䵽TI1
  	TIM2_ICInitStructure.TIM_ICPrescaler = TIM_ICPSC_DIV1;	 //Ƶ,Ƶ 
  	TIM2_ICInitStructure.TIM_ICFilter = 0x01;//IC1F=0000 ˲ ˲ //n=2 ˲
  	TIM_ICInit(TIM2, &TIM2_ICInitStructure);
	
	//жϷʼ
	NVIC_InitStructure.NVIC_IRQChannel = TIM2_IRQn;  //TIM2ж
	NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;  //ռȼ2
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;  //ȼ0
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE; //IRQͨʹ
	NVIC_Init(&NVIC_InitStructure);  //NVIC_InitStructָĲʼNVICĴ 
	
	TIM_ITConfig(TIM2,TIM_IT_Update|TIM_IT_CC1,ENABLE);//ж ,CC1IEж	
	
     TIM_Cmd(TIM2,ENABLE ); 	//ʹܶʱ2
 
}


u8  TIM2CH1_CAPTURE_STA=0;	//벶״̬		    				
u16	TIM2CH1_CAPTURE_VAL;	//벶ֵ
 
//ʱ2жϷ	 
void TIM2_IRQHandler(void)
{ 

 	if((TIM2CH1_CAPTURE_STA&0X80)==0)//δɹ	
	{	  
		
		//
		if (TIM_GetITStatus(TIM2, TIM_IT_Update) != RESET)
		 
		{	    
			if(TIM2CH1_CAPTURE_STA&0X40)//Ѿ񵽸ߵƽ
			{
				if((TIM2CH1_CAPTURE_STA&0X3F)==0X3F)//ߵƽ̫
				{
					TIM2CH1_CAPTURE_STA|=0X80;//ǳɹһ
					TIM2CH1_CAPTURE_VAL=0XFFFF;
				}else TIM2CH1_CAPTURE_STA++;
			}	 
		}
		
		//δ
		if (TIM_GetITStatus(TIM2, TIM_IT_CC1) != RESET)//1¼
		{	
			if(TIM2CH1_CAPTURE_STA&0X40)		//һϽ 		
			{	  			
				TIM2CH1_CAPTURE_STA|=0X80;		//ǳɹһ
				TIM2CH1_CAPTURE_VAL=TIM_GetCapture1(TIM2);
		   		TIM_OC1PolarityConfig(TIM2,TIM_ICPolarity_Falling); //CC1P=0 Ϊز
			}else  								//δʼ,һβ
			{
				TIM2CH1_CAPTURE_STA=0;			//
				TIM2CH1_CAPTURE_VAL=0;
	 			TIM_SetCounter(TIM2,0);
				TIM2CH1_CAPTURE_STA|=0X40;		//ǲ
		   		TIM_OC1PolarityConfig(TIM2,TIM_ICPolarity_Rising);		//CC1P=1 Ϊ½ز
			}		    
		}			     	    					   
 	}
 
    TIM_ClearITPendingBit(TIM2, TIM_IT_CC1|TIM_IT_Update); //жϱ־λ
 
}


